Fri Jan 15 01:59:02 CST 2010  pix@kepibu.org
  * Make MATCHING agree with MATCH[F][-CASE] about the conditions of failure
  Rather than skipping to the next clause on any error, UNIFICATION-FAILUREs--and
  /only/ UNIFICATION-FAILUREs--skip to the next clause.
diff -rN --strip-trailing-cr -u cl-unification/match-block.lisp cl-unification/match-block.lisp
--- cl-unification/match-block.lisp	2010-01-15 20:26:36.000000000 -0600
+++ cl-unification/match-block.lisp	2010-01-15 20:26:36.000000000 -0600
@@ -167,7 +167,7 @@
              (let ((template (%template-for-match template))
                    )
                `((setf ,clause-var
-                       (unify* ,template ,object ,substitution))
+                       (unify** ,template ,object ,substitution))
                  ,(%wrap-var-bindings template clause-var forms))
                ))
 
diff -rN --strip-trailing-cr -u cl-unification/unifier.lisp cl-unification/unifier.lisp
--- cl-unification/unifier.lisp	2010-01-15 20:26:36.000000000 -0600
+++ cl-unification/unifier.lisp	2010-01-15 20:26:36.000000000 -0600
@@ -859,6 +859,11 @@
 (defun unify* (a b &optional (env (make-empty-environment)))
   (ignore-errors (unify a b env)))
 
+(defun unify** (a b &optional (env (make-empty-environment)))
+  (handler-case
+      (unify a b env)
+    (unification-failure (c) (values nil c))))
+
 
 (defun unify-equations (eqns &optional (env (make-empty-environment)))
   (loop for (a b) in eqns

